
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/log/Statement.h"
#include "qpid/framing/FieldTable.h"
#include "qpid/management/Manageable.h" 
#include "qpid/agent/ManagementAgent.h"
#include "Sysimage.h"


using namespace qmf::com::redhat::sesame;
using namespace qpid::framing;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           std::string;

string  Sysimage::packageName  = string ("com.redhat.sesame");
string  Sysimage::className    = string ("sysimage");
uint8_t Sysimage::md5Sum[16]   =
    {0x73,0xa9,0xff,0xc5,0x24,0x1c,0xcc,0x9f,0x6b,0xf0,0x19,0xf2,0xe9,0xb3,0xd1,0x47};

Sysimage::Sysimage (ManagementAgent* _agent, Manageable* _core, const ::qpid::framing::Uuid& _uuid) :
    ManagementObject(_agent, _core),uuid(_uuid)
{
    
    osName = "";
    nodeName = "";
    release = "";
    version = "";
    machine = "";
    distro = "";
    memTotal = 0;
    swapTotal = 0;
    memFree = 0;
    swapFree = 0;
    loadAverage1Min = 0.;
    loadAverage5Min = 0.;
    loadAverage10Min = 0.;
    procTotal = 0;
    procRunning = 0;


    // Optional properties start out not-present
    for (uint8_t idx = 0; idx < 1; idx++)
        presenceMask[idx] = 0;


}

Sysimage::~Sysimage ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void Sysimage::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void Sysimage::writeSchema (Buffer& buf)
{
    FieldTable ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (9); // Config Element Count
    buf.putShort       (7); // Inst Element Count
    buf.putShort       (0); // Method Count

    // Properties
    ft.clear();
    ft.setString (NAME, "uuid");
    ft.setInt    (TYPE, TYPE_UUID);
    ft.setInt    (ACCESS, ACCESS_RC);
    ft.setInt    (IS_INDEX, 1);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "UUID of System Image");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "osName");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Operating System Name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "nodeName");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (DESC,   "Node Name");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "release");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "version");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "machine");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "distro");
    ft.setInt    (TYPE, TYPE_SSTR);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 1);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "memTotal");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "kByte");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME, "swapTotal");
    ft.setInt    (TYPE, TYPE_U32);
    ft.setInt    (ACCESS, ACCESS_RO);
    ft.setInt    (IS_INDEX, 0);
    ft.setInt    (IS_OPTIONAL, 0);
    ft.setString (UNIT,   "kByte");
    buf.put (ft);


    // Statistics
    ft.clear();
    ft.setString (NAME,   "memFree");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "kByte");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "swapFree");
    ft.setInt    (TYPE,   TYPE_U32);
    ft.setString (UNIT,   "kByte");
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "loadAverage1Min");
    ft.setInt    (TYPE,   TYPE_FLOAT);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "loadAverage5Min");
    ft.setInt    (TYPE,   TYPE_FLOAT);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "loadAverage10Min");
    ft.setInt    (TYPE,   TYPE_FLOAT);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "procTotal");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);

    ft.clear();
    ft.setString (NAME,   "procRunning");
    ft.setInt    (TYPE,   TYPE_U32);
    buf.put (ft);


    // Methods

}



void Sysimage::writeProperties (Buffer& buf)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    configChanged = false;

    writeTimestamps (buf);

    for (uint8_t idx = 0; idx < 1; idx++)
        buf.putOctet(presenceMask[idx]);

    uuid.encode(buf);
    buf.putShortString(osName);
    buf.putShortString(nodeName);
    buf.putShortString(release);
    buf.putShortString(version);
    buf.putShortString(machine);
    if (presenceMask[presenceByte_distro] & presenceMask_distro) {
        buf.putShortString(distro);
    }
    buf.putLong(memTotal);
    buf.putLong(swapTotal);

}

void Sysimage::writeStatistics (Buffer& buf, bool skipHeaders)
{
    ::qpid::sys::Mutex::ScopedLock mutex(accessLock);
    instChanged = false;



    if (!skipHeaders)
        writeTimestamps (buf);
    buf.putLong(memFree);
    buf.putLong(swapFree);
    buf.putFloat(loadAverage1Min);
    buf.putFloat(loadAverage5Min);
    buf.putFloat(loadAverage10Min);
    buf.putLong(procTotal);
    buf.putLong(procRunning);


    // Maintenance of hi-lo statistics


}

void Sysimage::doMethod (string&, Buffer&, Buffer& outBuf)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    outBuf.putLong(status);
    outBuf.putShortString(Manageable::StatusText(status, text));
}
